import BN from "bn.js";
import { MccClient, TransactionSuccessStatus } from "../../types";
import { AlgoTransactionTypeOptions, IAlgoGetTransactionRes } from "../../types/algoTypes";
import { AddressAmount, PaymentSummary, TransactionBase } from "../TransactionBase";
export declare class AlgoIndexerTransaction extends TransactionBase<IAlgoGetTransactionRes, any> {
    get txid(): string;
    get stdTxid(): string;
    get hash(): string;
    get reference(): string[];
    get stdPaymentReference(): string;
    get unixTimestamp(): number;
    get sourceAddresses(): string[];
    get receivingAddresses(): string[];
    get fee(): BN;
    get spentAmounts(): AddressAmount[];
    get receivedAmounts(): AddressAmount[];
    get type(): AlgoTransactionTypeOptions;
    get isNativePayment(): boolean;
    get currencyName(): string;
    get elementaryUnits(): BN;
    get successStatus(): TransactionSuccessStatus;
    paymentSummary(client?: MccClient, inUtxo?: number, utxo?: number, makeFullPayment?: boolean): Promise<PaymentSummary>;
}
//# sourceMappingURL=AlgoIndexerTransaction.d.ts.map