import BN from "bn.js";
import { MccClient, TransactionSuccessStatus } from "../../types";
import { IXrpGetTransactionRes } from "../../types/xrpTypes";
import { AddressAmount, PaymentSummary, TransactionBase } from "../TransactionBase";
export declare class XrpTransaction extends TransactionBase<IXrpGetTransactionRes, any> {
    get txid(): string;
    get stdTxid(): string;
    get hash(): string;
    get reference(): string[];
    get stdPaymentReference(): string;
    get unixTimestamp(): number;
    get sourceAddresses(): string[];
    get receivingAddresses(): string[];
    get fee(): BN;
    get spentAmounts(): AddressAmount[];
    get receivedAmounts(): AddressAmount[];
    get type(): string;
    get isNativePayment(): boolean;
    get currencyName(): string;
    get elementaryUnits(): BN;
    get successStatus(): TransactionSuccessStatus;
    paymentSummary(client: MccClient, inUtxo?: number, utxo?: number, makeFullPayment?: boolean): Promise<PaymentSummary>;
    get isAccountCreate(): boolean;
}
//# sourceMappingURL=XrpTransaction.d.ts.map