import { AlgoBlock, ReadRpcInterface } from "..";
import { AlgoNodeStatus } from "../base-objects/StatusBase";
import { AlgoTransaction } from "../base-objects/TransactionBase";
import { AlgoMccCreate, ChainType, IAlgoListTransactionRes, IAlgoLitsTransaction } from "../types";
export declare class ALGOImplementation implements ReadRpcInterface {
    algodClient: any;
    indexerClient: any;
    chainType: ChainType;
    inRegTest: boolean;
    createConfig: AlgoMccCreate;
    constructor(createConfig: AlgoMccCreate);
    /**
     * Return node status object for Algo node
     */
    getNodeStatus(): Promise<AlgoNodeStatus>;
    getBottomBlockHeight(): Promise<number>;
    getBlock(round?: number): Promise<AlgoBlock>;
    getBlockHeight(): Promise<number>;
    /**
     * get Transaction cannot be called on algorand's algod client, use getIndexerTransaction instead or get transactions from block
     * @param txid
     */
    getTransaction(txid: string): Promise<AlgoTransaction>;
    listTransactions(options?: IAlgoLitsTransaction): Promise<IAlgoListTransactionRes | null>;
    private getStatus;
    private getBlockHeaderCert;
    private getBlockHeader;
}
//# sourceMappingURL=AlgoRpcImplementation.d.ts.map