"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const src_1 = require("../../src");
const BtcMccConnection = {
    url: process.env.BTC_URL || "",
    username: process.env.BTC_USERNAME || "",
    password: process.env.BTC_PASSWORD || "",
};
describe("Chain tips test ", function () {
    let MccClient;
    let block;
    before(function () {
        return __awaiter(this, void 0, void 0, function* () {
            MccClient = new src_1.MCC.BTC(BtcMccConnection);
        });
    });
    it("Should get only latest tips ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            const tips = yield MccClient.getBlockTips(730698);
            console.log(tips);
        });
    });
    it("Should get tips and all blocks to certain height ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            const tips = yield MccClient.getTopLiteBlocks(5);
            console.log(tips);
        });
    });
});
//# sourceMappingURL=tips.test.js.map