"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const src_1 = require("../../src");
const DogeMccConnection = {
    url: process.env.DOGE_URL || "",
    username: process.env.DOGE_USERNAME || "",
    password: process.env.DOGE_PASSWORD || "",
};
describe("Block BTC base test ", function () {
    let MccClient;
    let status;
    before(function () {
        return __awaiter(this, void 0, void 0, function* () {
            MccClient = new src_1.MCC.DOGE(DogeMccConnection);
            const tstatus = yield MccClient.getNodeStatus();
            if (tstatus) {
                status = tstatus;
            }
        });
    });
    it("Should get status version ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            console.log(status.version);
        });
    });
    it("Should get status state ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            console.log(status.state);
        });
    });
    it("Should get status isHealthy ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            console.log(status.isHealthy);
        });
    });
    it("Should get status isSynced ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            console.log(status.isSynced);
        });
    });
    it("Should get full data ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            console.log(status.data);
        });
    });
});
//# sourceMappingURL=status.test.js.map