"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const chai_1 = require("chai");
const src_1 = require("../../src");
const LtcMccConnection = {
    url: process.env.LTC_URL || "",
    username: process.env.LTC_USERNAME || "",
    password: process.env.LTC_PASSWORD || "",
};
describe("Block LTC base test ", function () {
    let MccClient;
    let block;
    const blockNumber = 2220000;
    before(function () {
        return __awaiter(this, void 0, void 0, function* () {
            MccClient = new src_1.MCC.LTC(LtcMccConnection);
            block = yield MccClient.getBlock(blockNumber);
        });
    });
    it("Should get block", function () {
        return __awaiter(this, void 0, void 0, function* () {
            (0, chai_1.expect)(block).to.not.eq(undefined);
        });
    });
    it("Should get block number ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            (0, chai_1.expect)(block.number).to.eq(blockNumber);
        });
    });
    it("Should get block hash ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            (0, chai_1.expect)(block.blockHash).to.eq("2e7c0facdf8482585ee70161f07969e2201165a9632ea205b5f06a5ccc08c368");
        });
    });
    it("Should get block standard hash ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            (0, chai_1.expect)(block.stdBlockHash).to.eq("2e7c0facdf8482585ee70161f07969e2201165a9632ea205b5f06a5ccc08c368");
        });
    });
    it("Should get block timestamp ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            (0, chai_1.expect)(block.unixTimestamp).to.eq(1646170721);
        });
    });
    it("Should get transaction ids ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            (0, chai_1.expect)(block.transactionIds.length).to.eq(61);
            // TODO at least check some txids
        });
    });
    it("Should get transaction standard ids ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            (0, chai_1.expect)(block.stdTransactionIds.length).to.eq(61);
        });
    });
    it("Should get transaction count ", function () {
        return __awaiter(this, void 0, void 0, function* () {
            (0, chai_1.expect)(block.transactionCount).to.eq(61);
        });
    });
});
//# sourceMappingURL=block.test.js.map