export declare const MCC_ERROR = "mccError";
export declare enum mccErrorCode {
    InvalidParameter = 0,
    InvalidData = 1,
    InvalidBlock = 2,
    InvalidTransaction = 3,
    InvalidResponse = 4,
    InvalidMethodCall = 5,
    OutsideError = 6
}
export declare class mccError extends Error {
    errorCode: mccErrorCode;
    innerError: Error | undefined;
    constructor(errorCode: mccErrorCode, innerError?: Error);
}
export declare class mccOutsideError extends mccError {
    constructor(innerError: any);
}
export declare function AsyncTryCatchWrapper(): (target: Object, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
export declare function SyncTryCatchWrapper(): (target: Object, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
export declare function GetTryCatchWrapper(): (target: Object, propertyKey: string, descriptor: PropertyDescriptor) => PropertyDescriptor;
export declare function isPromise(p: any): boolean;
export declare function TryCatchWrapper(): (target: any, propertyKey?: string, descriptor?: PropertyDescriptor) => void;
export declare class DecoratorTest {
    val: number;
    constructor();
    get getter(): number;
    method(a: number, b: number): number;
    asyncMethod(a: number, b: number): Promise<number>;
}
//# sourceMappingURL=errors.d.ts.map