"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DecoratorTest = exports.TryCatchWrapper = exports.isPromise = exports.GetTryCatchWrapper = exports.SyncTryCatchWrapper = exports.AsyncTryCatchWrapper = exports.mccOutsideError = exports.mccError = exports.mccErrorCode = exports.MCC_ERROR = void 0;
const trace_1 = require("./trace");
exports.MCC_ERROR = "mccError";
var mccErrorCode;
(function (mccErrorCode) {
    mccErrorCode[mccErrorCode["InvalidParameter"] = 0] = "InvalidParameter";
    mccErrorCode[mccErrorCode["InvalidData"] = 1] = "InvalidData";
    mccErrorCode[mccErrorCode["InvalidBlock"] = 2] = "InvalidBlock";
    mccErrorCode[mccErrorCode["InvalidTransaction"] = 3] = "InvalidTransaction";
    mccErrorCode[mccErrorCode["InvalidResponse"] = 4] = "InvalidResponse";
    mccErrorCode[mccErrorCode["InvalidMethodCall"] = 5] = "InvalidMethodCall";
    mccErrorCode[mccErrorCode["OutsideError"] = 6] = "OutsideError";
})(mccErrorCode = exports.mccErrorCode || (exports.mccErrorCode = {}));
class mccError extends Error {
    constructor(errorCode, innerError) {
        super(mccErrorCode[errorCode]);
        this.name = exports.MCC_ERROR;
        this.errorCode = errorCode;
        this.innerError = innerError;
        //mccSettings?.loggingCallback( ".1.....");
        //mccSettings?.errorCallback( this );
        //mccSettings?.loggingCallback( ".2.....");
    }
}
exports.mccError = mccError;
class mccOutsideError extends mccError {
    constructor(innerError) {
        super(mccErrorCode.OutsideError, innerError);
    }
}
exports.mccOutsideError = mccOutsideError;
////////////////
// Decorators //
////////////////
function AsyncTryCatchWrapper() {
    return (target, propertyKey, descriptor) => {
        // const originalFn = descriptor.value;
        // descriptor.value = async function (...args: any[]) {
        //    try {
        //       return await originalFn.apply(this, args);
        //    } catch (error: any) {
        //       if (error?.name === MCC_ERROR) {
        //          throw error;
        //       }
        //       throw new mccOutsideError(error);
        //    }
        // };
        return descriptor;
    };
}
exports.AsyncTryCatchWrapper = AsyncTryCatchWrapper;
function SyncTryCatchWrapper() {
    return (target, propertyKey, descriptor) => {
        // const originalFn = descriptor.value;
        // descriptor.value = function (...args: any[]) {
        //    try {
        //       return originalFn.apply(this, args);
        //    } catch (error: any) {
        //       if (error?.name === MCC_ERROR) {
        //          throw error;
        //       }
        //       throw new mccOutsideError(error);
        //    }
        // };
        return descriptor;
    };
}
exports.SyncTryCatchWrapper = SyncTryCatchWrapper;
function GetTryCatchWrapper() {
    return (target, propertyKey, descriptor) => {
        //  if(descriptor.get){
        //   const originalGet = descriptor.get;
        //   descriptor.get = function () {
        //      try {
        //         return originalGet();
        //      } catch (error: any) {
        //         if (error?.name === MCC_ERROR) {
        //            throw error;
        //         }
        //         throw new mccOutsideError(error);
        //      }
        //   };
        //  }
        return descriptor;
    };
}
exports.GetTryCatchWrapper = GetTryCatchWrapper;
function isPromise(p) {
    if (typeof p === 'object' && typeof p.then === 'function') {
        return true;
    }
    return false;
}
exports.isPromise = isPromise;
function TryCatchWrapper() {
    return (target, propertyKey, descriptor) => {
        if (descriptor === null || descriptor === void 0 ? void 0 : descriptor.get) {
            const originalGet = descriptor.get;
            descriptor.get = function () {
                try {
                    return originalGet();
                }
                catch (error) {
                    if ((error === null || error === void 0 ? void 0 : error.name) === exports.MCC_ERROR) {
                        throw error;
                    }
                    throw new mccOutsideError(error);
                }
            };
        }
        else if ((descriptor === null || descriptor === void 0 ? void 0 : descriptor.value) && typeof descriptor.value === "function") {
            let original = descriptor.value;
            descriptor.value = function (...args) {
                try {
                    let res = original.apply(this, args);
                    if (!isPromise(res)) {
                        return res;
                    }
                    return new Promise((resolve, reject) => {
                        res.then(resolve).catch((error) => {
                            if ((error === null || error === void 0 ? void 0 : error.name) === exports.MCC_ERROR) {
                                reject(error);
                            }
                            reject(new mccOutsideError(error));
                        });
                    });
                }
                catch (error) {
                    if ((error === null || error === void 0 ? void 0 : error.name) === exports.MCC_ERROR) {
                        throw error;
                    }
                    throw new mccOutsideError(error);
                }
            };
        }
        else {
            Object.getOwnPropertyNames(target.prototype).forEach((methodName) => {
                let original = target.prototype[methodName];
                if (typeof original !== "function" || methodName === "constructor") {
                    return;
                }
                // an arrow function can't be used while we have to preserve right 'this'
                target.prototype[methodName] = function (...args) {
                    try {
                        let res = original.apply(this, args);
                        if (!isPromise(res)) {
                            console.log("Returning sync");
                            return res;
                        }
                        console.log("Returning Async");
                        return new Promise((resolve, reject) => {
                            res.then(resolve).catch((error) => {
                                if ((error === null || error === void 0 ? void 0 : error.name) === exports.MCC_ERROR) {
                                    reject(error);
                                }
                                reject(new mccOutsideError(error));
                            });
                        });
                    }
                    catch (error) {
                        if ((error === null || error === void 0 ? void 0 : error.name) === exports.MCC_ERROR) {
                            throw error;
                        }
                        throw new mccOutsideError(error);
                    }
                };
            });
        }
    };
}
exports.TryCatchWrapper = TryCatchWrapper;
//@TryCatchWrapper()
let DecoratorTest = class DecoratorTest {
    constructor() {
        this.val = 3;
        console.log("Constructor");
    }
    get getter() {
        console.log("Getter");
        return 1;
    }
    method(a, b) {
        if (b === 0)
            throw new Error("test crash");
        console.log(this);
        console.log(`Method ${a}, ${b} - val: ${this.val}`);
        return 55;
    }
    asyncMethod(a, b) {
        return __awaiter(this, void 0, void 0, function* () {
            if (b === 0)
                throw new Error("test crash");
            console.log(this);
            console.log(`Async Method ${a}, ${b} - val: ${this.val}`);
            return 55;
        });
    }
};
DecoratorTest = __decorate([
    (0, trace_1.Trace)()
], DecoratorTest);
exports.DecoratorTest = DecoratorTest;
//# sourceMappingURL=errors.js.map